## Script (Python) "getSchoolFee"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=brain=None
##title=
##
# $Id: getSchoolFee.py 2534 2007-11-05 06:37:12Z henrik $
"""
return SchoolFee
"""


ARTS = ('CRS','ISS','HIS','MUS','ECO','GEO','POL','SOS','CCA','ECU','THA','GED','GSE','PES','SPC','ENG ','FRE','ARB','HAU','IGB','YOR','FAA')

# SCS = ('BIO','CHE','HED','MAT','PED','PHY ','CSC','ISC','PHE','AGE','BED','HEC','TED')

d = {}

if not brain.mode.endswith('_sw'):
    if str(brain.level) == '000' and brain.review_state == 'cleared_and_validated':
        if brain.department in ARTS:
            d['all'] = 15900
        else:
            d['all'] = 16400
    elif str(brain.level) == '100' and brain.review_state == 'cleared_and_validated':
        if brain.department in ARTS:
            d['all'] = 13020
        else:
            d['all'] = 13495
    elif str(brain.level) == '100' and brain.review_state == 'returning':
        if brain.department in ARTS:
            d['all'] = 12070
        else:
            d['all'] = 12545
    elif str(brain.level) in ('200','210','220'):
        if brain.department in ARTS:
            d['all'] = 12070
        else:
            d['all'] = 12545
    # repeaters = spillover
    elif str(brain.level) in ('300','310','320'):
        if brain.department in ARTS:
            d['all'] = 10170
        else:
            d['all'] = 10645
    else:
        d['all'] = 0
else:
    if str(brain.level) == '100' and brain.review_state == 'cleared_and_validated':
        if brain.department in ARTS:
            d['all'] = 21900
        else:
            d['all'] = 22400
    elif str(brain.level) == '100' and brain.review_state == 'returning':
        if brain.department in ARTS:
            d['all'] = 18400
        else:
            d['all'] = 18900
    elif str(brain.level) in ('200','210','220'):
        if brain.department in ARTS:
            d['all'] = 20400
        else:
            d['all'] = 20900
    elif str(brain.level) in ('300','310','320'):
        if brain.department in ARTS:
            d['all'] = 18400
        else:
            d['all'] = 18900

    elif str(brain.level) in ('400','410','420'):
        if brain.department in ARTS:
            d['all'] = 18400
        else:
            d['all'] = 18900

    # repeaters = spillover
    elif str(brain.level) in ('500','510','520'):
        if brain.department in ARTS:
            d['all'] = 16900
        else:
            d['all'] = 17400
    else:
        d['all'] = 0


next_info = context.getNextInfo(brain)
next_session_str = next_info['next_session_str']
d['next_session_id'] = next_info['next_session_id']
d['description'] = "School Fee for Session %s" % next_session_str

return d

